﻿@{
    ViewBag.Title = "Clientes / Usuarios";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}

<style>
    .nowrap{
        white-space:nowrap;
    }
</style>


<div class="page-header">
    <h1 class="page-title">Listado de Clientes</h1>
    <div class="page-header-actions">
        
        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-primary" onclick="window.location.href = '/customers/CustomerUpdate/-1'">
                <i class="icon wb-plus" aria-hidden="true"></i>
                <span class="hidden-xs">NUEVO CLIENTE</span>
            </button>
        </div>

        @*<div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-primary" onclick="ResetCustomersShowTopBanner()">
                <i class="icon fa-long-arrow-down" aria-hidden="true"></i>
                <span class="hidden-xs">RESET TOP-BANNER</span>
            </button>
        </div>*@

        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-success" onclick="window.location.href='/customers/ExportToExcel'">
                <i class="icon fa-file-excel-o" aria-hidden="true"></i>
                <span class="hidden-xs">EXPORTAR A EXCEL</span>
            </button>
        </div>

    </div>
</div>

<div class="page-content">

    <div class="panel">
        <div class="panel-body">
            <table class="table table-hover dataTable table-striped width-full" id="dtCustomers">
                <thead>
                    <tr>
                        <th class="col-xs-3">Nombre y Apellido</th>
                        <th class="col-xs-2">Email</th>
                        <th class="col-xs-2">Provincia</th>
                        <th class="col-xs-2">Ciudad</th>
                        <th class="col-xs-1 text-center">Activo</th>
                        <th class="col-xs-1 text-center">Registro</th>
                        <th class="text-center">Acciones</th>
                    </tr>
                </thead>
            </table>
        </div>
    </div>

</div>

@section Scripts {

    <script type="text/javascript">

        var datatable;
        $(document).ready(function ()
        {
            datatable = $('#dtCustomers').DataTable({
                ajax: {
                    url: "/Customers/GetCustomers",
                    data : null,
                    type: "GET"
                },
                deferRender: true,
                columns: [
                    { "data": "FullName" },
                    { "data": "Email" },
                    { "data": "Province" },
                    { "data": "City" },                    
                    {
                        "data": "Enabled",
                        "className": "text-center",
                        "render": function (data, type, full, meta)
                        {
                            if(data)
                                return '<span class="badge badge-success">Si</span>';
                            else
                                return '<span class="badge badge-danger">No</span>';
                        }
                    },
                    { "data": "RegisterDateStr", "type": "date-arg", "className": "text-center" },
                    {
                        "className": "text-center no-wrap",
                        "render": function (data, type, full, meta)
                        {
                            var actions = "";

                            //Cuenta Corriente
                            actions += '<a href="/CustomerAccounting?Id=' + full.CustomerId + '" class="btn btn-sm btn-icon btn-pure btn-default on-default" data-toggle="tooltip" data-original-title="Cuenta Corriente" data-rowid="' + full.CustomerId + '"><i class="icon wb-list aria-hidden="true"></i></a>';

                            //Historial de  Compras
                            actions += '<a href="/Customers/OrderHistory/' + full.CustomerId + '" class="btn btn-sm btn-icon btn-pure btn-default on-default" data-toggle="tooltip" data-original-title="Ver Historial de Compras" data-rowid="' + full.CustomerId + '"><i class="icon wb-replay aria-hidden="true"></i></a>';

                            //Editar
                            actions += '<a href="/Customers/CustomerUpdate/' + full.CustomerId + '" class="btn btn-sm btn-icon btn-pure btn-default on-default" data-toggle="tooltip" data-original-title="Editar" data-rowid="' + full.CustomerId + '"><i class="icon wb-edit aria-hidden="true"></i></a>';

                            //Eliminar
                            actions += '<a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default" data-toggle="tooltip" data-original-title="Eliminar" data-row-id="' + full.CustomerId + '" onclick="fDeleteDialog(' + full.CustomerId + ')"><i class="icon wb-trash aria-hidden="true"></i></a>';

                            return actions;
                        }
                    }
                ]
            });

            $("#dtCustomers").tooltip({
                selector: '[data-toggle="tooltip"]'
            });
        });

        function fConfirmCustomer(Id)
        {
            $(".confirm").prop("disabled", true);
            $("#ajax-loader").css("display", "block");
            $.ajax({
                url: "/Customers/CustomerConfirm/" + Id,
                type: "POST",
                data: null,
                success: function (data, textStatus, jqXHR)
                {
                    $(".confirm").prop("disabled", false);
                    $("#ajax-loader").css("display", "none");
                    $('.panel-body').html(data);
                    $('.dataTable').DataTable();
                    //setActionsDialogs();
                    swal("Confirmado", "El usuario ha sido notificado vía email.", "success");
                }
            });
        }

        function fRejectCustomer(Id) {
            $(".reject").prop("disabled", true);
            $("#ajax-loader").css("display", "block");
            $.ajax({
                url: "/Customers/CustomerReject",
                type: "POST",
                data: {Id : Id},
                success: function (data, textStatus, jqXHR) {
                    $(".reject").prop("disabled", false);
                    $("#ajax-loader").css("display", "none");
                    $('.panel-body').html(data);
                    $('.dataTable').DataTable();
                    //setActionsDialogs();
                    swal("Rechazado", "El usuario ha sido notificado vía email.", "success");
                }
            });
        }

        function fDelete(Id)
        {
            $.ajax({
                url: "/Customers/CustomerDelete/" + Id,
                type: "GET",
                data: null,
                success: function (data, textStatus, jqXHR)
                {
                    $('[data-row-id="' + Id + '"]').closest('tr').remove();
                    swal("Eliminado!", "", "success");
                    datatable.ajax.reload(null, false);
                    
                    /*$('.panel-body').html(data);
                    $('.dataTable').DataTable();
                    //setActionsDialogs();*/
                }
            });
        }

        function fDeleteDialog(customerId)
        {
            var customerId = customerId;
            swal({
                title: "Confirma su acción de Eliminar?",
                text: "",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo elminarlo!',
                cancelButtonText: 'Cancelar',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm)
            {
                if (isConfirm)
                {
                    fDelete(customerId);
                }
            });
        }

        function fConfirmDialog(customerId)
        {
            var customerId = customerId;
            swal({
                title: "",
                text: "Desea confirmar al usuario?",
                showCancelButton: true,
                confirmButtonColor: '#46be8a',
                confirmButtonText: 'Sí, deseo confirmarlo.',
                cancelButtonText: 'Cancelar',
                closeOnConfirm: false,
                closeOnCancel: true
                },
                function (isConfirm)
                {
                    if (isConfirm)
                    {
                        fConfirmCustomer(customerId);
                    }
                });
        }

        function fRejectDialog(customerId) {
            var customerId = customerId;
            swal({
                title: "",
                text: "Desea rechazar al usuario?",
                showCancelButton: true,
                confirmButtonColor: '#46be8a',
                confirmButtonText: 'Sí, deseo rechazarlo.',
                cancelButtonText: 'Cancelar',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isRejected) {
                if (isRejected) {
                    fRejectCustomer(customerId);
                }
            });
        }

        function ResetCustomersShowTopBanner()
        {
            swal({
                title: "",
                text: "Desea confirmar su acción?",
                showCancelButton: true,
                confirmButtonColor: '#46be8a',
                confirmButtonText: 'Sí, actualizar.',
                cancelButtonText: 'Cancelar',
                closeOnConfirm: false,
                closeOnCancel: true
            },
                function (isConfirm) {
                    if (isConfirm) {
                        $.ajax({
                            url: "/Customers/ResetCustomersShowTopBanner",
                            type: "POST",
                            data: null,
                            success: function (data, textStatus, jqXHR) {
                                if (data)
                                    swal("Listo!", "", "success");
                                else
                                    swal("Se produjo un error al realizar la operación.", "", "danger");
                            }
                        });
                    }
                });
        }

    </script>
}

